using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class TransferInConfiguration : IEntityTypeConfiguration<TransferIn>
{
    public void Configure(EntityTypeBuilder<TransferIn> builder)
    {
        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.TransferOutId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.TransferOut)
            .WithMany()
            .HasForeignKey(e => e.TransferOutId)
            .OnDelete(DeleteBehavior.NoAction);

        builder.HasIndex(e => e.AutoNumber).IsUnique();
        builder.HasIndex(e => e.TransferReceiveDate);
        builder.HasIndex(e => e.TransferOutId);
    }
}